# nng_http_server_set_tls(3http) Manual Page

## NAME

nng_http_server_set_tls - set HTTP server TLS configuration

## SYNOPSIS

    #include <nng/nng.h>
    #include <nng/supplemental/http/http.h>

    int nng_http_server_set_tls(nng_http_server *s, nng_tls_config *cfg);

## DESCRIPTION

The `nng_http_server_set_tls()` sets the TLS configuration of server s to cfg.

This change overwrites any previous TLS configuration.

| This also invalidates any previously obtained values from `nng_http_server_get_tls()`.

If the server is already running (i.e. it has been started with `nng_http_server_start()`) then this will fail with `NNG_EBUSY`.

| Generally, the cfg must have a configured private key, set with `nng_tls_config_own_cert()` or similar.

## RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

## ERRORS

`NNG_EBUSY` | Server instance is running.
`NNG_ENOMEM` | Insufficient free memory exists.
`NNG_ENOTSUP` | Either HTTP or TLS not supported.

## SEE ALSO

nng_http_server_get_tls(3http), nng_http_server_hold(3http), nng_http_server_start(3http), nng_tls_config_alloc(3tls), nng_strerror(3), nng(7)